<?php
namespace Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;

class Sup14000EvolucaoPrecoNegociacoesController extends \Zeedhi\Framework\Controller\Report
        
{
    protected $connection;
    protected $birtStrategy;
    protected $environment;
    
    public  function __construct($reportService, $birtStrategy, $connection, $environment)
    {
        parent::__construct($reportService);
        $this->birtStrategy  =   $birtStrategy;
        $this->connection    =   $connection;
        $this->environment   =   $environment;
    }
    
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {   
        $row = $request->getRow();
        $this->stNomeRel = $this->getReportName($row);
        $row['NRORG'] = $this->environment->getNrOrg();
        $this->reportMapping[$this->stNomeRel] =
        array(
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
            array (
                'L_CDOPERADOR'   => "P_CDOPERADOR",
                "L_CDFORNECED"   => 'P_CDFORNECED',
                "L_CDREGIAO"     => 'P_CDREGIAO',
                "CDARVPRODINI"   => 'P_CDARVPRODINI',
                "CDARVPRODFIN"   => 'P_CDARVPRODFIN',
                "DTINIPERCOT"    => 'P_DTINIPERCOT',
                "DTFINPERCOT"    => 'P_DTFINPERCOT',
                "NRORG"          => 'P_NRORG'
            )
        );
    }
}


