<?php

namespace Services;
use Doctrine\DBAL\Connection;

class LogRotinasDoPortalService
{

    public function __construct($entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    public function getGridData($conditions)
    {   
        $periodo = $this->getValueInFilterDataSourceByName($conditions, 'PERIODO');

        $DTINI = $periodo[0];
        $DTFIM = $periodo[1];

        if(!$DTINI || !$DTFIM) {
            throw new Exception("Parameters not found");
        }


        $query = "SELECT DTOPERACAO, IDTIPOOPER, DSOPERACAO
        FROM LOGOPERA
        WHERE NMTABELA = 'PARAMGERALECOMMERCE'
        AND DTOPERACAO BETWEEN TRUNC(TO_DATE('$DTINI', 'DD/MM/YYYY')) AND TRUNC(TO_DATE('$DTFIM', 'DD/MM/YYYY') + 1)
        AND DTOPERACAO < TRUNC(TO_DATE('$DTFIM', 'DD/MM/YYYY') + 1)
        ORDER BY DTOPERACAO ASC";


        $response = ($this->connection->fetchAll($query));
        
        $insertArr = array (
            'Visualizar Dados:',
            'Fale Conosco:',
            'Nome Link Aux.:',
            'Link Aux.:',
            'Empresa:',
            'Exibe Qtde:',
            'Link Eco:',
            'Grava Itm Zero:',
            'Unica Cot:',
            'CBC ALTERADO' ,
            'Manual:',
        );

        // update - 2, 1 - insert, 3 - delete
        
        $retorno = [];

        foreach($response as $res) {
            $dsoperacao = $res['DSOPERACAO'];
            $IDTIPOOPER = $res['IDTIPOOPER'];


            if($IDTIPOOPER == 2) {
                $pattern = "/".implode("|", $insertArr)."/";
    
                $contents = [];
        
                preg_match_all ($pattern, $dsoperacao, $contents);
        
               
                $result = preg_split($pattern, $dsoperacao, -1, PREG_SPLIT_NO_EMPTY);
        
                $content = $contents[0];
        
                $frontEndNames = array(
                    'Fale Conosco:'     => 'faleconosco',
                    'Nome Link Aux.:'   => 'detalhes',          
                    'Link Aux.:'        => 'descricao-opcional',
                    'Empresa:'          => 'empresa',
                    'Exibe Qtde:'       => 'quantidade-media',
                    'Unica Cot:'        => 'cotacao-unica',
                    'Grava Itm Zero:'   => 'itens-com-preco',
                    'Link Eco:'         => 'endereco-portal'
                );
        
                $array = [];
        
                foreach($content as $key => $value) {
        
                    if(isset($frontEndNames[$value])) {
    
                        $setar = $result[$key];
    
                        if(trim($result[$key]) == 'S') {
    
                            $setar = 'Sim';
    
                        } else if(trim($result[$key]) == 'N') {
    
                            $setar = 'Não';
    
                        } 
    
                        $array = array_merge($array, array($frontEndNames[$value] => $setar));
                    }
                    
                }
    
        
                $array['data'] = $res['DTOPERACAO'];
        
                $array['operacao'] = $res['IDTIPOOPER'];
                
    
                $retorno[] = $array;

            } else {

                $a = array(
                    'Fale Conosco ' => 'faleconosco',
                    'Nome Link Aux. ' => 'detalhes',
                    'Link Aux. ' => 'descricao-opcional',
                    'Empresa '   => 'empresa',
                    'Exibe Qtde ' => 'quantidade-media',
                    'Link Eco '   => 'endereco-portal',
                    'Grava Itm Zero ' => 'itens-com-preco',
                    'Unica Cot ' =>  'cotacao-unica',
                );
                ///Visualiza Dados  |Fale Conosco |Nome Link Aux. /    
                
                $subject = "Visualizar Dados   Fale Conosco  Nome Link Aux. Meu nome ";
                $pattern = "/".implode("|", $a)."/";
                $result = preg_split($pattern, $dsoperacao, -1, PREG_SPLIT_NO_EMPTY);
                
                foreach($a as $key => $value){
                    if(isset($frontEndNames[$value])) {
    
                        $setar = $result[$key];
    
                        if(trim($result[$key]) == 'S') {
    
                            $setar = 'Sim';
    
                        } else if(trim($result[$key]) == 'N') {
    
                            $setar = 'Não';
    
                        } 
    
                        $array = array_merge($array, array($frontEndNames[$value] => $setar));
                    }
                    
                }

                $array['data'] = $res['DTOPERACAO'];
        
                $array['operacao'] = $res['IDTIPOOPER'];
                
    
                $retorno[] = $array;
            }
            
        }

        return $retorno;

    }


    private function getValueInFilterDataSourceByName(array &$filters,$nameFilter,$remove = false)
    {
        foreach ($filters as $key => $filter) {
            $name = $filter['columnName'];
            $values = $filter['value'];
            if($name == $nameFilter ){
                if($remove){
                    unset($filters[$key]);
                }
                return $values;
            }
        }
        return null;
    }
}
