/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GERECOMP                                                 */
/* Tabela : GERECOMP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_GERECOMP
BEFORE INSERT OR UPDATE OR DELETE
ON GERECOMP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGECO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDOPERCOMP,0) <> NVL(:NEW.CDOPERCOMP,0)) OR
         (NVL(:OLD.CDOPERGERE,0) <> NVL(:NEW.CDOPERGERE,0)) OR
         (NVL(:OLD.CDNIVELAPROVCMP,0) <> NVL(:NEW.CDNIVELAPROVCMP,0)) THEN
         :NEW.DTULTATUGECO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GERECOMP', '', 'CDOPERGERE='||:OLD.CDOPERGERE||';CDOPERCOMP='||:OLD.CDOPERCOMP, SYSDATE);
   END IF;
END;
/

ALTER TABLE GERECOMP MODIFY DTULTATUGECO DEFAULT SYSDATE
/
